package cn.com.qmth.ac.controller;

import javax.annotation.Resource;

import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;

import cn.com.qmth.ac.bean.RedirectParam;
import cn.com.qmth.ac.bean.SystemConstant;
import cn.com.qmth.ac.service.CommonService;
import cn.com.qmth.ac.util.Result;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + SystemConstant.PREFIX_URL_OPEN)
@Validated
public class OpenApiController {

    @Resource
    private CommonService commonService;

    @ApiOperation(value = "cas鉴权接口")
    @ApiResponses({ @ApiResponse(code = 200, message = "返回消息", response = Result.class) })
    @RequestMapping(value = "auth/login/{schoolCode}", method = RequestMethod.GET)
    @Aac(auth = false)
    public void authentication(@ApiParam(value = "学校编码") @PathVariable("schoolCode") String schoolCode) {
        RedirectParam redirectParams = commonService.authentication(schoolCode);
        commonService.redirect(redirectParams);
    }

    @ApiOperation(value = "cas鉴权退出接口")
    @RequestMapping(value = "auth/logout/{schoolCode}", method = RequestMethod.GET)
    @ApiResponses({ @ApiResponse(code = 200, message = "返回消息", response = Result.class) })
    @Aac(auth = false)
    public void logout(@ApiParam(value = "学校编码") @PathVariable("schoolCode") String schoolCode,
            @ApiParam(value = "sessionId", required = false) @RequestParam(required = false) String gSessionId) {
        commonService.logout(schoolCode);
    }

}
